#include <dlfcn.h>
#include <iostream>
#include <exception>
#include <string>
#include "module.h"

class exc : public std::exception {
public:
  exc (std::string str) : message (str) { }
  ~exc () throw () { }
  virtual const char *what () const throw ()
  {
    return message.c_str ();
  }
private:
  std::string message;
};

int exceptions_in_module (void)
{
  std::cerr << "exceptions_in_module\n";

  void *handle = dlopen ("module.dll", RTLD_GLOBAL | RTLD_LAZY);
  if (handle == NULL)
    {
      std::cerr << "dlopen failed: " << dlerror () << '\n';
      return 1;
    }

  typedef int (*pfun) (void);
  pfun pf = (pfun) dlsym (handle, "modfoo");
  if (pf == NULL)
    {
      std::cerr << "dlsym failed: " << dlerror () << '\n';
      return 1;
    }

  try {
    (*pf) ();
  }
  catch (modexc e) {
    std::cerr << "caught: " << e.what () << '\n';
    if (dlclose (handle))
      {
        std::cerr << "dlclose failed: " << dlerror () << '\n';
        return 1;
      }
    return 0;
  }
  return 1;
}

int main (void)
{
  if (exceptions_in_module ())
    return 1;
  return 0;
}
